/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * Topic
 */

public class Topic {
  @JsonProperty("created_at")
  private LocalDateTime createdAt = null;

  @JsonProperty("datasets")
  private List<Dataset> datasets = null;

  @JsonProperty("deleted")
  private LocalDateTime deleted = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("featured")
  private Boolean featured = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("last_modified")
  private LocalDateTime lastModified = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("owner")
  private Object owner = null;

  @JsonProperty("page")
  private String page = null;

  @JsonProperty("private")
  private Boolean _private = null;

  @JsonProperty("reuses")
  private List<Reuse> reuses = null;

  @JsonProperty("slug")
  private String slug = null;

  @JsonProperty("tags")
  private List<String> tags = new ArrayList<String>();

  @JsonProperty("uri")
  private String uri = null;

   /**
   * The topic creation date
   * @return createdAt
  **/
  @ApiModelProperty(value = "The topic creation date")
  public LocalDateTime getCreatedAt() {
    return createdAt;
  }

  public Topic datasets(List<Dataset> datasets) {
    this.datasets = datasets;
    return this;
  }

  public Topic addDatasetsItem(Dataset datasetsItem) {
    if (this.datasets == null) {
      this.datasets = new ArrayList<Dataset>();
    }
    this.datasets.add(datasetsItem);
    return this;
  }

   /**
   * The topic datasets
   * @return datasets
  **/
  @ApiModelProperty(value = "The topic datasets")
  public List<Dataset> getDatasets() {
    return datasets;
  }

  public void setDatasets(List<Dataset> datasets) {
    this.datasets = datasets;
  }

   /**
   * The organization identifier
   * @return deleted
  **/
  @ApiModelProperty(value = "The organization identifier")
  public LocalDateTime getDeleted() {
    return deleted;
  }

  public Topic description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The topic description in Markdown
   * @return description
  **/
  @ApiModelProperty(required = true, value = "The topic description in Markdown")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Topic featured(Boolean featured) {
    this.featured = featured;
    return this;
  }

   /**
   * Is the topic featured
   * @return featured
  **/
  @ApiModelProperty(value = "Is the topic featured")
  public Boolean isFeatured() {
    return featured;
  }

  public void setFeatured(Boolean featured) {
    this.featured = featured;
  }

  public Topic id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The topic identifier
   * @return id
  **/
  @ApiModelProperty(value = "The topic identifier")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

   /**
   * The topic last modification date
   * @return lastModified
  **/
  @ApiModelProperty(value = "The topic last modification date")
  public LocalDateTime getLastModified() {
    return lastModified;
  }

  public Topic name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The topic name
   * @return name
  **/
  @ApiModelProperty(required = true, value = "The topic name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Topic owner(Object owner) {
    this.owner = owner;
    return this;
  }

   /**
   * The owner user
   * @return owner
  **/
  @ApiModelProperty(value = "The owner user")
  public Object getOwner() {
    return owner;
  }

  public void setOwner(Object owner) {
    this.owner = owner;
  }

   /**
   * The topic page URL
   * @return page
  **/
  @ApiModelProperty(value = "The topic page URL")
  public String getPage() {
    return page;
  }

  public Topic _private(Boolean _private) {
    this._private = _private;
    return this;
  }

   /**
   * Is the topic private
   * @return _private
  **/
  @ApiModelProperty(value = "Is the topic private")
  public Boolean isPrivate() {
    return _private;
  }

  public void setPrivate(Boolean _private) {
    this._private = _private;
  }

  public Topic reuses(List<Reuse> reuses) {
    this.reuses = reuses;
    return this;
  }

  public Topic addReusesItem(Reuse reusesItem) {
    if (this.reuses == null) {
      this.reuses = new ArrayList<Reuse>();
    }
    this.reuses.add(reusesItem);
    return this;
  }

   /**
   * The topic reuses
   * @return reuses
  **/
  @ApiModelProperty(value = "The topic reuses")
  public List<Reuse> getReuses() {
    return reuses;
  }

  public void setReuses(List<Reuse> reuses) {
    this.reuses = reuses;
  }

   /**
   * The topic permalink string
   * @return slug
  **/
  @ApiModelProperty(value = "The topic permalink string")
  public String getSlug() {
    return slug;
  }

  public Topic tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public Topic addTagsItem(String tagsItem) {
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Some keywords to help in search
   * @return tags
  **/
  @ApiModelProperty(required = true, value = "Some keywords to help in search")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

   /**
   * The topic API URI
   * @return uri
  **/
  @ApiModelProperty(value = "The topic API URI")
  public String getUri() {
    return uri;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Topic topic = (Topic) o;
    return Objects.equals(this.createdAt, topic.createdAt) &&
        Objects.equals(this.datasets, topic.datasets) &&
        Objects.equals(this.deleted, topic.deleted) &&
        Objects.equals(this.description, topic.description) &&
        Objects.equals(this.featured, topic.featured) &&
        Objects.equals(this.id, topic.id) &&
        Objects.equals(this.lastModified, topic.lastModified) &&
        Objects.equals(this.name, topic.name) &&
        Objects.equals(this.owner, topic.owner) &&
        Objects.equals(this.page, topic.page) &&
        Objects.equals(this._private, topic._private) &&
        Objects.equals(this.reuses, topic.reuses) &&
        Objects.equals(this.slug, topic.slug) &&
        Objects.equals(this.tags, topic.tags) &&
        Objects.equals(this.uri, topic.uri);
  }

  @Override
  public int hashCode() {
    return Objects.hash(createdAt, datasets, deleted, description, featured, id, lastModified, name, owner, page, _private, reuses, slug, tags, uri);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Topic {\n");

    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    datasets: ").append(toIndentedString(datasets)).append("\n");
    sb.append("    deleted: ").append(toIndentedString(deleted)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    featured: ").append(toIndentedString(featured)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    owner: ").append(toIndentedString(owner)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    _private: ").append(toIndentedString(_private)).append("\n");
    sb.append("    reuses: ").append(toIndentedString(reuses)).append("\n");
    sb.append("    slug: ").append(toIndentedString(slug)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    uri: ").append(toIndentedString(uri)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

